#ifndef _INPUT_H
#define _INPUT_H 1

#include <string>

#include "thread.h"

class Input;
class InputProto;

// Extremely rudimentary URL parsing.
bool parse_url(const std::string &url, std::string *protocol, std::string *host, std::string *port, std::string *path);

// Figure out the right type of input based on the URL, and create a new Input of the right type.
// Will return NULL if unknown.
Input *create_input(const std::string &stream_id, const std::string &url);
Input *create_input(const InputProto &serialized);

class Input : public Thread {
public:
	virtual ~Input();
	virtual InputProto serialize() const = 0;
	virtual std::string get_url() const = 0;
	virtual void close_socket() = 0;
};

#endif  // !defined(_INPUT_H)
